local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_LOGIN")
frame:SetScript("OnEvent", function(self,event)

	if not miniTipDB then
		miniTipDB = {
			["hidetitle"] = true,
			["hiderealm"] = true,
			["classicon"] = true,
			["raceicon"] = true,
			["classiconsize"] = 40,
			["raceiconsize"] = 40,
			["targetoftarget"] = true,
		} 
	end
	
	local miniTip = "|cFFFF9900miniTip|r"
	local skull = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8.blp:0|t"
	local backdrop = GameTooltip:GetBackdrop()
	local unavailable = "Interface\\CHARACTERFRAME\\TempPortrait.blp"
	local races = {
	   [3] = {
		  ["BloodElf"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-BLOODELF.BLP",
		  ["Draenei"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-DRAENEI.BLP",
		  ["Dwarf"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-DWARF.BLP",
		  ["Gnome"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-GNOME.BLP",
		  ["Goblin"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-GOBLIN.BLP",
		  ["Human"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-HUMAN.BLP",
		  ["NightElf"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-NIGHTELF.BLP",
		  ["Orc"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-ORC.BLP",
		  ["Pandaren"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-PANDAREN.BLP",
		  ["Scourge"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-SCOURGE.BLP",
		  ["Tauren"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-TAUREN.BLP",
		  ["Troll"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-TROLL.BLP",
		  ["Worgen"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-FEMALE-WORGEN.BLP",
	   },
	   
	   [2] = {
		  ["BloodElf"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-BLOODELF.BLP",
		  ["Draenei"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-DRAENEI.BLP",
		  ["Dwarf"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-DWARF.BLP",
		  ["Gnome"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-GNOME.BLP",
		  ["Goblin"] = "Interface\\CHARACTERFRAME\\TemporaryPortrait-Male-Goblin.blp",
		  ["Human"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-HUMAN.BLP",
		  ["NightElf"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-NIGHTELF.BLP",
		  ["Orc"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-ORC.BLP",
		  ["Pandaren"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-PANDAREN.BLP",
		  ["Scourge"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-SCOURGE.BLP",
		  ["Tauren"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-TAUREN.BLP",
		  ["Troll"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-TROLL.BLP",
		  ["Worgen"] = "Interface\\CHARACTERFRAME\\TEMPORARYPORTRAIT-MALE-WORGEN.BLP",
	   },
	}

	local gap = 3

	local myClassIcon = CreateFrame("Frame", nil, GameTooltip)
	myClassIcon:SetBackdrop(backdrop)
	local myClassIcontex = myClassIcon:CreateTexture(nil, "ARTWORK")
	myClassIcontex:SetPoint("TOPLEFT",myClassIcon,"TOPLEFT",gap,-gap)
	myClassIcontex:SetPoint("BOTTOMRIGHT",myClassIcon,"BOTTOMRIGHT",-gap,gap)
	myClassIcon:SetPoint("TOPLEFT",GameTooltip,"TOPRIGHT",-3,0)
	myClassIcon:SetParent(GameTooltip)

	local myRaceIcon = CreateFrame("Frame", nil, GameTooltip)
	myRaceIcon:SetBackdrop(backdrop)
	myRaceIcon:SetPoint("TOPLEFT",myClassIcon,"BOTTOMLEFT",0,3)
	local myRaceIcontex = myRaceIcon:CreateTexture(nil, "ARTWORK")
	myRaceIcontex:SetPoint("TOPLEFT",myRaceIcon,"TOPLEFT",gap+2,-gap-2)
	myRaceIcontex:SetPoint("BOTTOMRIGHT",myRaceIcon,"BOTTOMRIGHT",-gap-2,gap+2)	
	myRaceIcon:SetParent(GameTooltip)

	local myToT = CreateFrame("Frame", nil, UIParent)
	myToT:SetBackdrop(backdrop)
	myToT:SetPoint("BOTTOMLEFT",GameTooltip,"TOPLEFT",0,-3)
	myToT:SetBackdropColor(0,0,0,0.8)
	myToT.row1 = myToT:CreateFontString(nil, "ARTWORK", "GameTooltipHeaderText")
	myToT.row1:SetPoint("TOPLEFT",myToT,"TOPLEFT",9,-9)
	myToT:SetParent(GameTooltip)

	local function updateTooltip()
		if UnitExists("mouseover") and UnitIsPlayer("mouseover") then
		
			-- Let's gather info
			local guid = UnitGUID("mouseover")
			local class, classFilename, race, raceFilename, sex, name, realm = GetPlayerInfoByGUID(guid)
			local fullname = UnitPVPName("mouseover")
			if realm == "" or not realm then realm = "" else realm = "-"..realm end
			if not name then name = "N/A" end
			if not class then class = "N/A" end
			if not race then race = "N/A" end
			if not fullname then fullanme = "N/A" end
			local lines = GameTooltip:NumLines()
			local guild = GetGuildInfo("mouseover") and 0 or 1
			local pvp = UnitIsPVP("mouseover")
			local afk = UnitIsAFK("mouseover")
			if afk then afk = "|cff7f7f7f<AFK>" else afk = "" end
			local level = UnitLevel("mouseover")
			local diff = GetQuestDifficultyColor(level)

			local reactioncolor = FACTION_BAR_COLORS[UnitReaction("mouseover", "player")]
			GameTooltip:SetBackdropBorderColor(reactioncolor.r,reactioncolor.g,reactioncolor.b,1)

			-- Line 1
			if miniTipDB.hiderealm then
				realm = ""
			end

			if miniTipDB.hidetitle then
				fullname = name
			end
			GameTooltipTextLeft1:SetFormattedText("%s%s %s",fullname,realm,afk)
			-- Recolor name to match Class at line 1
			local classcolor = RAID_CLASS_COLORS[classFilename] and RAID_CLASS_COLORS[classFilename] or { r = 0.5, g = 0.5, b = 0.5 }
			GameTooltipTextLeft1:SetTextColor(classcolor.r,classcolor.g,classcolor.b,1)

			-- Line 2
			if level == -1 then level = skull end
			local levelhex = string.format("|cff%02x%02x%02x"..level.."|r", diff.r*255, diff.g*255, diff.b*255)
			local classhex = string.format("|cff%02x%02x%02x"..class.."|r", classcolor.r*255, classcolor.g*255, classcolor.b*255)
			-- Recolor Level, race and class at line 2 ( if guild visible, line 3 )
			_G["GameTooltipTextLeft"..3-guild]:SetFormattedText("Level %s %s %s", levelhex, race, classhex)

			-- Line 3
			-- Recolor faction at line 3 ( if guild visible, line 4 )
			_G["GameTooltipTextLeft"..4-guild]:SetTextColor(reactioncolor.r,reactioncolor.g,reactioncolor.b,1)
			
			-- Line 5
			-- Recolor PvP text at line 4 ( if guild visible, line 5 )
			if pvp then
				_G["GameTooltipTextLeft"..5-guild]:SetTextColor(0,1,0,1)
			end

			-- Resize tooltip ( if title/realm has been removed )
			local maxline = 0
			for i=2,lines do
				local linelength = _G["GameTooltipTextLeft"..i]:GetWidth()
				if linelength > maxline then maxline = linelength end
			end
			GameTooltip:SetWidth(maxline)
			GameTooltip:Show()

			-- Show Target of mouseover
			local targettarget = UnitName("mouseovertarget")
			if miniTipDB.targetoftarget and targettarget then
				local mouseovertarget = UnitName("mouseovertarget")
				if (UnitIsUnit("mouseovertarget","player")) then
					mouseovertarget = ">> YOU <<"
				end
				local reactioncolor = FACTION_BAR_COLORS[UnitReaction("mouseover", "player")]
				local text = string.format("Targeting: |cff%02x%02x%02x"..mouseovertarget.."|r", reactioncolor.r*255, reactioncolor.g*255, reactioncolor.b*255)
				myToT.row1:SetText(text)
				myToT:SetSize(myToT.row1:GetWidth()+20,32)
				myToT:SetBackdropBorderColor(reactioncolor.r,reactioncolor.g,reactioncolor,b,1)
				myToT:Show()
			end
			
			-- Show mouseover Class
			if miniTipDB.classicon then
				local t = CLASS_ICON_TCOORDS[classFilename]
				if not t then
					myClassIcontex:SetTexture(unavailable)
					myClassIcontex:SetTexCoord(0,1,0,1)
				else
					myClassIcontex:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
					myClassIcontex:SetTexCoord(unpack(t))
				end
				myClassIcon:SetBackdropBorderColor(classcolor.r,classcolor.g,classcolor.b,1)
				myClassIcon:SetBackdropColor(classcolor.r,classcolor.g,classcolor.b,1)
				myClassIcon:SetSize(miniTipDB.classiconsize,miniTipDB.classiconsize)
				myClassIcon:Show()
				myRaceIcon:SetPoint("TOPLEFT",myClassIcon,"BOTTOMLEFT",0,3)
			else
				myRaceIcon:SetPoint("TOPLEFT",GameTooltip,"TOPRIGHT",-3,0)
			end
		
			if miniTipDB.raceicon then
				-- Show mouseover Race
				if not sex or not raceFilename then
					myRaceIcontex:SetTexture(unavailable)
				else
					myRaceIcontex:SetTexture(races[sex][raceFilename])
				end
				myRaceIcon:SetBackdropBorderColor(reactioncolor.r,reactioncolor.g,reactioncolor.b,1)
				myRaceIcon:SetBackdropColor(reactioncolor.r,reactioncolor.g,reactioncolor.b,1)
				myRaceIcon:SetSize(miniTipDB.raceiconsize,miniTipDB.raceiconsize)
				myRaceIcon:Show()
			end
		end
	end

	-- Hide all extra
	local function hideTooltip()
		myToT:Hide()
		myClassIcon:Hide()
		myRaceIcon:Hide()
	end

	self:UnregisterEvent(event)
	GameTooltip:HookScript("OnTooltipSetUnit", updateTooltip)
	GameTooltip:HookScript("OnUpdate", updateTooltip)
	GameTooltip:HookScript("OnHide", hideTooltip)

	hooksecurefunc("GameTooltip_SetDefaultAnchor", function(tooltip, parent)
		local frame = GetMouseFocus()
		if frame == WorldFrame then
			tooltip:SetOwner(parent, "ANCHOR_CURSOR")
		else
			tooltip:ClearAllPoints()
			tooltip:SetOwner(parent, "ANCHOR_NONE")
			tooltip:SetPoint("BOTTOMLEFT",frame,"TOPLEFT",-4,3)
		end
	end)
	
	SLASH_miniTip1 = "/mt"
	SLASH_miniTip2 = "/minitip"
	SlashCmdList["miniTip"] = function(msg) 
		local a, b = strsplit(" ", msg, 2)
		if a == "title" then
			if miniTipDB.hidetitle then miniTipDB.hidetitle = false else miniTipDB.hidetitle = true end
			ChatFrame1:AddMessage(miniTip..": Hiding title: "..tostring(miniTipDB.hidetitle))
		elseif a == "realm" then
			if miniTipDB.hiderealm then miniTipDB.hiderealm = false else miniTipDB.hiderealm = true end
			ChatFrame1:AddMessage(miniTip..": Hiding realm: "..tostring(miniTipDB.hiderealm))
		elseif a == "class" then
			if b and tonumber(b) and (tonumber(b) >= 20 and tonumber(b) <= 100) then
				miniTipDB.classiconsize = b
				ChatFrame1:AddMessage(miniTip..": Changing Class icon size to: "..tostring(miniTipDB.classiconsize))
			elseif not b then
				if miniTipDB.classicon then miniTipDB.classicon = false else miniTipDB.classicon = true end
				ChatFrame1:AddMessage(miniTip..": Showing Class icon: "..tostring(miniTipDB.classicon))
			else
				ChatFrame1:AddMessage(miniTip..": Error, give proper value. Example: /minitip class "..miniTipDB.classiconsize)
			end
		elseif a == "race" then
			if b and tonumber(b) and (tonumber(b) >= 20 and tonumber(b) <= 100) then
				miniTipDB.raceiconsize = b
				ChatFrame1:AddMessage(miniTip..": Changing Race icon size to: "..tostring(miniTipDB.raceiconsize))
			elseif not b then
				if miniTipDB.raceicon then miniTipDB.raceicon = false else miniTipDB.raceicon = true end
				ChatFrame1:AddMessage(miniTip..": Showing Race icon: "..tostring(miniTipDB.raceicon))
			else
				ChatFrame1:AddMessage(miniTip..": Error, give proper value. Example: /minitip race "..miniTipDB.raceiconsize)
			end
		elseif a == "target" then
			if miniTipDB.targetoftarget then miniTipDB.targetoftarget = false else miniTipDB.targetoftarget = true end
			ChatFrame1:AddMessage(miniTip..": Showing Target of Target: "..tostring(miniTipDB.targetoftarget))
		else
			ShowUIPanel(ItemRefTooltip)
			if not ItemRefTooltip:IsShown() then ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE") end
			ItemRefTooltip:ClearLines()
			ItemRefTooltip:AddLine(miniTip..": Accepting following slashcommands:")
			ItemRefTooltip:AddDoubleLine(" /minitip title","- Toggle Title true/false")
			ItemRefTooltip:AddDoubleLine(" /minitip realm","- Toggle Realm true/false")
			ItemRefTooltip:AddDoubleLine(" /minitip target","- Toggle ToT true/false")
			ItemRefTooltip:AddDoubleLine(" /minitip class","- Toggle Class true/false")
			ItemRefTooltip:AddDoubleLine(" /minitip race","- Toggle Race true/false")
			ItemRefTooltip:AddDoubleLine(" /minitip class X","- Change Class icon size, 20-100")
			ItemRefTooltip:AddDoubleLine(" /minitip race X","- Change Race icon size, 20-100")
			ItemRefTooltip:Show()
		end
	end

end)